// Copyright (c) 2023 ETH Zurich.
//                    All rights reserved.
//
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.
//
// main author: Wojciech Chlapek

#ifndef __NOD_LOCK_H
#define __NOD_LOCK_H

#include "gdi.h"

/**
  constant definitions
 */
#define NOD_NO_LOCK     190
#define NOD_READ_LOCK   191
#define NOD_WRITE_LOCK  192


/**
  function prototypes
 */
void NOD_AcquireVertexReadLock( GDI_VertexHolder vertex );
void NOD_UpdateToVertexWriteLock( GDI_VertexHolder vertex );
/**
  NOD_SetVertexWriteLock should only be called from GDI_CreateVertex,
  after the primary block is acquired from the free memory management,
  so we already know, that we are the only process with access to that
  block
 */
void NOD_SetVertexWriteLock( GDI_VertexHolder vertex );
void NOD_ReleaseVertexLock( GDI_VertexHolder vertex );

#endif // __NOD_LOCK_H
